/********************						***********************/
//
//	Player PRO 4.4x -- MOD to MADx & MADx to MOD
//
//	Version 1.0	- 12.3.95 ANR
//
//	To use with CodeWarrior 68K or PPC
//
//	Antoine ROSSET
//	16 Tranchees
//	1206 GENEVA
//	SWITZERLAND
//	
//	FAX:			(+41 22) 346 11 97
//	Compuserve:		100277,164
//	Internet: 		rosset@dial.eunet.ch
//
/********************						***********************/

#include "MOD.h"
#include "MAD.h"
#include "RDriver.h"
#include "PPInOut.h"

#if defined(powerc) || defined(__powerc)
enum {
		PlayerPROPlug = kCStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof( OSType)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof( Ptr*)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof( MADPartition*)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof( PPInfoRec*)))
		| STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof( short**)))
};

ProcInfoType __procinfo = PlayerPROPlug;
#else
#include <A4Stuff.h>
#endif

void AnalyseSignatureMOD( long temp, short *maxInstru, long *PatternSize, short *tracksNo, MODDef* aMOD)
{
	long 		test, i;
	Boolean		result;

	*maxInstru = 31;

	switch( temp)
	{
		case 'FLT4':	*PatternSize = sizeof( struct MODCom) * 64L * 4L;	*tracksNo = 4;	break;
		case 'FLT8':	*PatternSize = sizeof( struct MODCom) * 64L * 4L;	*tracksNo = 4;	break;
		case 'M.K.':	*PatternSize = sizeof( struct MODCom) * 64L * 4L;	*tracksNo = 4;	break;
		case '5CHN':	*PatternSize = sizeof( struct MODCom) * 64L * 5L;	*tracksNo = 5;	break;
		case '6CHN':	*PatternSize = sizeof( struct MODCom) * 64L * 6L;	*tracksNo = 6;	break;
		case '7CHN':	*PatternSize = sizeof( struct MODCom) * 64L * 7L;	*tracksNo = 7;	break;
		case '8CHN':	*PatternSize = sizeof( struct MODCom) * 64L * 8L;	*tracksNo = 8;	break;
		case '9CHN':	*PatternSize = sizeof( struct MODCom) * 64L * 9L;	*tracksNo = 9;	break;
		case '10CH':	*PatternSize = sizeof( struct MODCom) * 64L * 10L;	*tracksNo = 10;	break;
		case '11CH':	*PatternSize = sizeof( struct MODCom) * 64L * 11L;	*tracksNo = 11;	break;
		case '12CH':	*PatternSize = sizeof( struct MODCom) * 64L * 12L;	*tracksNo = 12;	break;
		case '13CH':	*PatternSize = sizeof( struct MODCom) * 64L * 13L;	*tracksNo = 13;	break;
		case '14CH':	*PatternSize = sizeof( struct MODCom) * 64L * 14L;	*tracksNo = 14;	break;
		case '15CH':	*PatternSize = sizeof( struct MODCom) * 64L * 15L;	*tracksNo = 15;	break;
		case '16CH':	*PatternSize = sizeof( struct MODCom) * 64L * 16L;	*tracksNo = 16;	break;
		case '17CH':	*PatternSize = sizeof( struct MODCom) * 64L * 17L;	*tracksNo = 17;	break;
		case '18CH':	*PatternSize = sizeof( struct MODCom) * 64L * 18L;	*tracksNo = 18;	break;
		case '19CH':	*PatternSize = sizeof( struct MODCom) * 64L * 19L;	*tracksNo = 19;	break;
		case '20CH':	*PatternSize = sizeof( struct MODCom) * 64L * 20L;	*tracksNo = 20;	break;
		case '21CH':	*PatternSize = sizeof( struct MODCom) * 64L * 21L;	*tracksNo = 21;	break;
		case '22CH':	*PatternSize = sizeof( struct MODCom) * 64L * 22L;	*tracksNo = 22;	break;
		case '23CH':	*PatternSize = sizeof( struct MODCom) * 64L * 23L;	*tracksNo = 23;	break;
		case '24CH':	*PatternSize = sizeof( struct MODCom) * 64L * 24L;	*tracksNo = 24;	break;
		case '25CH':	*PatternSize = sizeof( struct MODCom) * 64L * 25L;	*tracksNo = 25;	break;
		case '26CH':	*PatternSize = sizeof( struct MODCom) * 64L * 26L;	*tracksNo = 26;	break;
		case '27CH':	*PatternSize = sizeof( struct MODCom) * 64L * 27L;	*tracksNo = 27;	break;
		case '28CH':	*PatternSize = sizeof( struct MODCom) * 64L * 28L;	*tracksNo = 28;	break;
		case '29CH':	*PatternSize = sizeof( struct MODCom) * 64L * 29L;	*tracksNo = 29;	break;
		case '30CH':	*PatternSize = sizeof( struct MODCom) * 64L * 30L;	*tracksNo = 30;	break;
		case '31CH':	*PatternSize = sizeof( struct MODCom) * 64L * 31L;	*tracksNo = 31;	break;
		case '32CH':	*PatternSize = sizeof( struct MODCom) * 64L * 32L;	*tracksNo = 32;	break;
		
		default:
			*PatternSize 	= sizeof( struct MODCom) * 64L * 4L;			*tracksNo = 4;
			
			result = true;
			test = 0;
			for( i = 0; i < 15; i++)
			{
				test += aMOD->fid[i].numWords;
				if( aMOD->fid[i].fineTune > 0x0F) result = false;
			}
			if( test == 0) result = false;
						
			if( result) *maxInstru 		= 15;
			else *maxInstru 			= 0;
		break;
	}
}

short FoundNote( short Period, short *MADpitchTable)
{
short	NCount = 1;
	
	while( NCount < NUMBER_NOTES+1)
    {
    	if( Period >= MADpitchTable[ NCount]) return( NCount);
    	NCount++;
    }
    
    return 0;
}

struct Command* GetMADCommand( register short PosX, register short	TrackIdX, register	struct MusicPattern*	tempMusicPat)
{
	if( PosX < 0) PosX = 0;
	else if( PosX >= tempMusicPat->header.PatternSize) PosX = tempMusicPat->header.PatternSize -1;
		
	return( & (tempMusicPat->Commands[ (tempMusicPat->header.PatternSize * TrackIdX) + PosX]));
}

struct MODCom* GetMODCommand( short position, short whichTracks, short whichPattern, short maxTracks, Ptr PatPtr)
{
	struct MODCom*	myMODCom;
	
	myMODCom =	(struct MODCom*) (PatPtr +
				whichPattern * 64L * sizeof( struct MODCom) * maxTracks +
				position * sizeof( struct MODCom) * maxTracks +
				whichTracks * sizeof( struct MODCom));
	
	return myMODCom;
}

OSErr PPConvertMod2Mad( Ptr aMOD,long MODSize, MADPartition	*theMAD, short *MADpitchTable)
{
	short 			i, PatMax, x, tracksNo, z, maxInstru;
	long 			sndSize, OffSetToSample, MPatSize, temp, inOutCount;
	Ptr				MaxPtr;
	OSErr			theErr;
	Ptr				theInstrument[ 64], destPtr;
	
	/**** Variables for MAD File *****/
	struct Command		*aCmd;

	/**** Variables for MOD File *****/
	MODDef 				*theMOD;
	struct MODPat		*PatInt;
	MODDef				*MODInt;
	struct MODCom		*theCommand;
	/********************************/
	
	theMOD = ((MODDef*) aMOD);
	MaxPtr = (Ptr)((long) theMOD + MODSize);

	temp = *((long*)(aMOD + 0x438));		// Signature...

	AnalyseSignatureMOD( temp, &maxInstru, &MPatSize, &tracksNo, theMOD);
	
	if( maxInstru == 0)
	{
		return fileNotSupportedByThisPlug;	// This file is NOT a Mod file !!!!!! This should NEVER happen !
	}
	else if( maxInstru == 15)				// Old Mods format with 15 instruments
	{
		MODInt = (MODDef*) ( (Ptr) theMOD - (Ptr) 0x1E0);
		PatInt = (struct MODPat*) ((Ptr) MODInt->patterns - (Ptr) 0x4);

		PatMax = 0;
		for(i=0; i<64; i++)
		{
			if( MODInt->oPointers[i] < 0) MODInt->oPointers[i] = 0;
			if( MODInt->oPointers[i] > 128) MODInt->oPointers[i] = 0;
		
			if( MODInt->oPointers[i] >= PatMax)	PatMax = MODInt->oPointers[i];
		}
		PatMax++;
		
		OffSetToSample = (long) 0x258 + PatMax * MPatSize;
	}
	else									// Mods format with 32 instruments
	{
		MODInt	= theMOD;
		PatInt	= MODInt->patterns;
	
		PatMax = 0;
		for(i=0; i<128; i++)
		{
			if( MODInt->oPointers[i] < 0) MODInt->oPointers[i] = 0;
			if( MODInt->oPointers[i] > 128) MODInt->oPointers[i] = 0;
			
			if( MODInt->oPointers[i] >= PatMax) PatMax = MODInt->oPointers[i];
		}
		PatMax++;
		
		OffSetToSample = (long) 0x43c + PatMax * MPatSize;
	}
	
	for( i = 0; i < maxInstru ; i++)
	{
		theInstrument[i] = (Ptr) ((long) theMOD + (long) OffSetToSample);

		sndSize = ((long) theMOD->fid[i].numWords) * 2L;
	
		if( theInstrument[i] + sndSize > MaxPtr)
		{
			theMOD->fid[i].numWords = MaxPtr - theInstrument[i];
			theMOD->fid[i].numWords /= 2L;
			
			if( theMOD->fid[i].numWords < 0) theMOD->fid[i].numWords = 0;
					
			sndSize = ((long) theMOD->fid[i].numWords) * 2L;
		}
		
		OffSetToSample += sndSize;

		if( theMOD->fid[i].loopWords > 2 && sndSize > 0)
		{
			if( (long) theMOD->fid[i].loopWord +
				(long) theMOD->fid[i].loopWords > 
				(long) theMOD->fid[i].numWords)
			{
				theMOD->fid[ i].loopWords =	(long) theMOD->fid[i].numWords -
											(long) theMOD->fid[i].loopWord;
		
				if( (long) theMOD->fid[i].loopWord +
				(long) theMOD->fid[i].loopWords > 
				(long) theMOD->fid[i].numWords)
				{
					theMOD->fid[i].loopWord = 0;
					theMOD->fid[i].loopWords = 0;
				}
			}
		}
		else
		{
			theMOD->fid[i].loopWord = 0;
			theMOD->fid[i].loopWords = 0;
		}
	}
	
	/***************************************************************/
	/******** MOD is ready to be converted into MAD File ***********/
	/***************************************************************/
	
	inOutCount = sizeof( MADSpec);
	theMAD->header = (MADSpec*) NewPtrClear( inOutCount);	
	if( theMAD->header == 0L) DebugStr("\pHeader: I NEED MEMORY !!! NOW !");
	
	theMAD->header->MADIdentification = 'MADG';
	
	for(i=0; i<22; i++) theMAD->header->NameSignature[i] = theMOD->NameSignature[i];
	
	theMAD->header->PatMax = PatMax;
	theMAD->header->numPointers = MODInt->numPointers;
	
	for(i=0; i<128; i++) theMAD->header->oPointers[ i] = MODInt->oPointers[ i];
	
	theMAD->header->Tracks = tracksNo;

	for(i = 0; i < maxInstru; i++)
	{
		for( x = 0; x < 22; x++) theMAD->header->fid[i].Filename[x] = theMOD->fid[i].Filename[x];
		theMAD->header->fid[i].insSize		= theMOD->fid[i].numWords * 2L;
		theMAD->header->fid[i].fineTune		= theMOD->fid[i].fineTune;
		theMAD->header->fid[i].volume 		= theMOD->fid[i].volume;
		theMAD->header->fid[i].freq 		= 1;
		theMAD->header->fid[i].amplitude	= 8;
		theMAD->header->fid[i].loopStart 	= theMOD->fid[i].loopWord*2L;
		theMAD->header->fid[i].loopLenght 	= theMOD->fid[i].loopWords*2L;
		
		if( theMAD->header->fid[ i].insSize > 0)
		{
			theMAD->instrument[ i] = NewPtr( theMAD->header->fid[i].insSize);
			if( theMAD->instrument[ i] == 0L) DebugStr("\pInstruments: I NEED MEMORY !!! NOW !");
			
			BlockMove( theInstrument[i], theMAD->instrument[i], theMAD->header->fid[i].insSize);
		}
		else theMAD->instrument[i] = 0L;
	}
	
	for( i = maxInstru; i < MAXINSTRU ; i++)
	{
		theMAD->instrument[i] 				= 0L;
		theMAD->header->fid[i].volume 		= 64;
		theMAD->header->fid[i].freq 		= 1;
		theMAD->header->fid[i].amplitude	= 8;
	}
	
	for(i=0; i<theMAD->header->PatMax; i++)
	{
		theMAD->partition[ i] = (struct	MusicPattern*) NewPtrClear( sizeof( struct MusicPattern) + theMAD->header->Tracks * 64L * sizeof( struct Command));
		if( theMAD->partition[ i] == 0L) DebugStr("\pPatterns: I NEED MEMORY !!! NOW !");
		
		theMAD->partition[ i]->header.PatternSize 		= 64L;
		theMAD->partition[ i]->header.CompressionMode 	= 'NONE';
		
		for( x = 0; x < 20; x++) theMAD->partition[ i]->header.PatternName[ x] = 0;
		
		theMAD->partition[ i]->header.PatBytes = 0L;		theMAD->partition[ i]->header.unused2 = 0L;
	
		MaxPtr = (Ptr) theMAD->partition[ i];
		MaxPtr += sizeof( struct MusicPattern) + theMAD->header->Tracks * 64L * sizeof( struct Command);

		for(x=0; x<64; x++)
		{
			for(z=0; z<theMAD->header->Tracks; z++)
			{
				aCmd = GetMADCommand(  x,  z, theMAD->partition[ i]);
				if( (Ptr) aCmd + sizeof( struct Command) > MaxPtr) DebugStr("\pConversion ERROR");
				
				theCommand 	= GetMODCommand(	x,
												z,
												i,
												theMAD->header->Tracks,
												(Ptr) PatInt);
				
				aCmd->InstrumentNo = (theCommand->InstrLoNibble & 0x0F) + (theCommand->InstrHiNibble << 4);
				aCmd->AmigaPeriod = FoundNote( theCommand->AmigaPeriod, MADpitchTable);
				aCmd->EffectCmd = theCommand->EffectCmd & 0x0F;
				aCmd->EffectArg = theCommand->EffectArg & 0x00FF;
			}
		}
	}
	for( i = theMAD->header->PatMax; i < MAXPATTERN ; i++) theMAD->partition[ i] = 0L;

	return noErr;
}

Ptr PPConvertMad2Mod( MADPartition *theMAD)
{
	short 				i, x, z, maxInstru;
	long 				sndSize, OffSetToSample, temp, InstruSize, *alpha;
	Ptr					MaxPtr;
	OSErr				theErr;
	Ptr					theInstrument[ 64], destPtr;
	Boolean				CheckGoodMod;
	Str255				tempStr;
	char				redut[4];
	short				MODTuning[ 65] =
						{	0,
							1712,1616,1525,1440,1357,1281,1209,1141,1077,1017, 961, 907,
							856,808,762,720,678,640,604,570,538,508,480,453,
							428,404,381,360,339,320,302,285,269,254,240,226,
							214,202,190,180,170,160,151,143,135,127,120,113,
							107,101, 95, 90, 85, 80, 76, 71, 67, 64, 60, 57 };
							
	/**** Variables for MAD file ****/
	
	struct Command		*aCmd;

	/**** Variables for MOD file ****/
	
	MODDef 				*theMOD;
	struct MODCom		*theCommand;
	/********************************/

	maxInstru = 31;
	
	OffSetToSample = theMAD->header->PatMax * theMAD->header->Tracks * 64L * sizeof( struct Command);
	OffSetToSample += sizeof( MADSpec);
	
	InstruSize = 0;
	for( i = 0; i < maxInstru ; i++)
	{
		theInstrument[i] = theMAD->instrument[i];
		OffSetToSample += theMAD->header->fid[i].insSize;
		InstruSize += theMAD->header->fid[i].insSize;
	}
	
	/******** MAD is ready to be converted **********/
	/******** Copy information in the MOD file    ***/
	
	theMOD = (MODDef*) NewPtr( 0x43c + InstruSize + theMAD->header->Tracks * 64L * theMAD->header->PatMax * sizeof( struct MODCom));
	if( theMOD == 0L) return 0L;
	
	theMOD->longFmtSignature = 'M.K.';
	if( theMAD->header->Tracks > 4)
	{
		NumToString( theMAD->header->Tracks, tempStr);
		if( tempStr[ 0] == 2)
		{
			redut[0] = tempStr[1];
			redut[1] = tempStr[2];
			redut[2] = 'C';
			redut[3] = 'H';
		}
		else if( tempStr[ 0] == 1)
		{
			redut[0] = tempStr[1];
			redut[1] = 'C';
			redut[2] = 'H';
			redut[3] = 'N';
		}
		
		alpha = (long*) redut;
		
		theMOD->longFmtSignature = *alpha;
	}
	
	MaxPtr = (Ptr) theMOD + GetPtrSize( (Ptr) theMOD);
	
	for(i=0; i<20; i++) theMOD->NameSignature[i] = theMAD->header->NameSignature[i];
	
	CheckGoodMod = false;
	theMOD->numPointers = theMAD->header->numPointers;
	for(i=0; i<128; i++)
	{
		theMOD->oPointers[ i] = theMAD->header->oPointers[ i];
		if( theMOD->oPointers[ i] == theMAD->header->PatMax - 1) CheckGoodMod = true;
	}
	if( !CheckGoodMod) theMOD->oPointers[ theMOD->numPointers + 1] = theMAD->header->PatMax - 1;
	
	for(i=0; i<maxInstru; i++)
	{
		for( x = 0; x < 22; x++) theMOD->fid[i].Filename[x] = theMAD->header->fid[i].Filename[x];
		
		if( theMAD->header->fid[i].insSize/2L > 0xFFFFUL) theMOD->fid[i].numWords = 0xFFFFUL;
		else theMOD->fid[i].numWords = (short) (theMAD->header->fid[i].insSize / 2L);
		
		theMOD->fid[i].fineTune = theMAD->header->fid[i].fineTune;
		theMOD->fid[i].volume = theMAD->header->fid[i].volume;
		theMOD->fid[i].loopWord = theMAD->header->fid[i].loopStart / 2L;
		theMOD->fid[i].loopWords = theMAD->header->fid[i].loopLenght / 2L;
	}
	
	InstruSize = 0L;
	
	OffSetToSample = (long) 0x43c + theMAD->header->PatMax * sizeof( struct MODCom) * 64L * theMAD->header->Tracks;
	
	for(i=0; i<maxInstru; i++)
	{
		destPtr = (Ptr) ((long) theMOD + (long) OffSetToSample + (long) InstruSize);
	
		if( destPtr  + (long) (theMOD->fid[i].numWords) * 2L <= MaxPtr) BlockMove( theInstrument[i], destPtr, (long) (theMOD->fid[i].numWords) * 2L);
		else DebugStr("\pInstrument Error");
		
		InstruSize += (long) (theMOD->fid[i].numWords) * 2L;
	}
	
	for(i=0; i<theMAD->header->PatMax; i++)
	{
		for(x=0; x < 64; x++)
		{
			for(z=0; z < theMAD->header->Tracks; z++)
			{
				aCmd 		= GetMADCommand( 	x,
												z,
												theMAD->partition[ i]);
				
				theCommand 	= GetMODCommand(	x,
												z,
												i,
												theMAD->header->Tracks,
												(Ptr) theMOD->patterns);
												
				if( (Ptr) theCommand > MaxPtr) DebugStr("\pCommand Error");
				
				theCommand->InstrLoNibble = (aCmd->InstrumentNo & 0x0F);
				theCommand->InstrHiNibble = (aCmd->InstrumentNo >> 4);
				if( aCmd->AmigaPeriod > 0) theCommand->AmigaPeriod = MODTuning[ aCmd->AmigaPeriod - 1];
				else theCommand->AmigaPeriod = 0;
				theCommand->EffectCmd = aCmd->EffectCmd;
				theCommand->EffectArg = aCmd->EffectArg;
			}
		}
	}
	
	return( (Ptr) theMOD);
}

OSErr ExtractMODInfo( PPInfoRec *info, Ptr AlienFile)
{
	MODDef	*myMOD = ( MODDef*) AlienFile;
	long	PatternSize;
	short	i;
	short	maxInstru;
	short	tracksNo;
	
	/*** Signature ***/
	
	info->signature = myMOD->longFmtSignature;
	
	/*** Internal name ***/
	
	myMOD->NameSignature[ 19] = '\0';
	pStrcpy( info->internalFileName, CtoPstr( myMOD->NameSignature));

	/*** Check MOD Type ***/
	
	AnalyseSignatureMOD( info->signature, &maxInstru, &PatternSize, &info->totalTracks, myMOD);
	if( maxInstru == 0)
	{
		return fileNotSupportedByThisPlug;
	}
	else if( maxInstru == 15)	// Old mod format
	{
		info->signature = '----';
		myMOD = (MODDef*) ((Ptr) myMOD - (Ptr) 0x1E0);
	}
	
	/*** Total Patterns ***/
	
	info->totalPatterns = 0;
	for( i = 0; i < 128; i++)
	{
		if( myMOD->oPointers[ i] >= info->totalPatterns)	info->totalPatterns = myMOD->oPointers[ i];
	}
	info->totalPatterns++;
	
	/*** Partition Length ***/
	
	info->partitionLength = myMOD->numPointers;
	
	/*** Total Instruments ***/
	
	for( i = 0, info->totalInstruments = 0; i < maxInstru ; i++)
	{
		if( myMOD->fid[ i].numWords > 5) info->totalInstruments++;
	}
	
	pStrcpy( info->formatDescription, "\pMOD Plug");

	return noErr;
}

OSErr TestMODFile( Ptr AlienFile)
{
	short	maxInstru;
	long	PatternSize;
	short	tracksNo;
	
	AnalyseSignatureMOD( *((long*)(AlienFile + 0x438)), &maxInstru, &PatternSize, &tracksNo, (MODDef*) AlienFile);
	
	if( maxInstru == 0) return fileNotSupportedByThisPlug;
	else return noErr;
}

void pStrcpy(register unsigned char *s1, register unsigned char *s2)
{
	register short len, i;
	
	len = *s2;
	for ( i = 0; i <= len; i++) s1[ i] = s2[ i];
}

/*****************/
/* MAIN FUNCTION */
/*****************/

OSErr main( OSType order, FSSpec *AlienFileFSSpec, MADPartition *MadFile, PPInfoRec *info, short *MADpitchTable)
{
	OSErr	myErr;
	Ptr		AlienFile;
	short	vRefNum, iFileRefI;
	long	dirID, sndSize;
	
#ifndef powerc
	long	oldA4 = SetCurrentA4(); 			//this call is necessary for strings in 68k code resources
#endif

	HGetVol( 0L, &vRefNum, &dirID);
	HSetVol( 0L, AlienFileFSSpec->vRefNum, AlienFileFSSpec->parID);

	myErr = noErr;

	switch( order)
	{
		case 'IMPL':
			myErr = FSOpen( AlienFileFSSpec->name, 0, &iFileRefI);
			if( myErr == noErr)
			{
				GetEOF( iFileRefI, &sndSize);
			
				// ** MEMORY Test Start
				AlienFile = NewPtr( sndSize * 2L);
				if( AlienFile == 0L) myErr = needMoreMemory;
				// ** MEMORY Test End
				
				else
				{
					DisposPtr( AlienFile);
					
					AlienFile = NewPtr( sndSize);
					myErr = FSRead( iFileRefI, &sndSize, AlienFile);
					if( myErr == noErr)
					{
						myErr = TestMODFile( AlienFile);
						if( myErr == noErr)
						{
							myErr = PPConvertMod2Mad( AlienFile, GetPtrSize( AlienFile), MadFile, MADpitchTable);
						}
					}
					DisposPtr( AlienFile);	AlienFile = 0L;
				}
				FSClose( iFileRefI);
			}
		break;
		
		case 'TEST':
			myErr = FSOpen( AlienFileFSSpec->name, 0, &iFileRefI);
			if( myErr == noErr)
			{
				sndSize = 5000L;	// Read only 5000 first bytes for optimisation
				
				AlienFile = NewPtr( sndSize);
				if( AlienFile == 0L) myErr = needMoreMemory;
				else
				{
					myErr = FSRead( iFileRefI, &sndSize, AlienFile);
					myErr = TestMODFile( AlienFile);
					
					DisposPtr( AlienFile);	AlienFile = 0L;
				}
				FSClose( iFileRefI);
			}
		break;
		
		case 'EXPL':
			AlienFile = PPConvertMad2Mod( MadFile);
			
			if( AlienFile != 0L)
			{
				myErr = FSOpen( AlienFileFSSpec->name, 0, &iFileRefI);
				if( myErr == fnfErr)
				{
					myErr = Create( AlienFileFSSpec->name, 0, 'SNPL', 'STrk');
					myErr = FSOpen( AlienFileFSSpec->name, 0, &iFileRefI);
				}
				
				if( myErr == noErr)
				{
					FInfo	fndrInfo;
				
					sndSize = GetPtrSize( AlienFile);
					myErr = SetEOF( iFileRefI, sndSize);
					if( myErr == noErr)
					{
						myErr = FSWrite( iFileRefI, &sndSize, AlienFile);
					}
					FSClose( iFileRefI);
					
					GetFInfo( AlienFileFSSpec->name, 0, &fndrInfo);
					fndrInfo.fdCreator	= 'SNPL';
					fndrInfo.fdType		= 'STrk';
					SetFInfo( AlienFileFSSpec->name, 0, &fndrInfo);
				}
				DisposPtr( AlienFile);	AlienFile = 0L;
			}
		break;

		case 'INFO':
			myErr = FSOpen( AlienFileFSSpec->name, 0, &iFileRefI);
			if( myErr == noErr)
			{
				GetEOF( iFileRefI, &info->fileSize);
			
				sndSize = 5000L;	// Read only 5000 first bytes for optimisation
				
				AlienFile = NewPtr( sndSize);
				if( AlienFile == 0L) myErr = needMoreMemory;
				else
				{
					myErr = FSRead( iFileRefI, &sndSize, AlienFile);
					if( myErr == noErr)
					{
						myErr = ExtractMODInfo( info, AlienFile);
					}
					DisposPtr( AlienFile);	AlienFile = 0L;
				}
				FSClose( iFileRefI);
			}
		break;
		
		default:
			myErr = orderNotImplemented;
		break;
	}

	HSetVol( 0L, vRefNum, dirID);

	#ifndef powerc
		SetA4( oldA4);
	#endif
	return myErr;
}