#ifndef COMPIL68K 
#pragma options align=mac68k
#endif

typedef struct
{
	long	name;
	long	length;
} sectheader;

typedef struct
{
      char				name[20];
      long				length;
      unsigned short 	repeat;
      unsigned short 	replen;
      char 				pad1;
      unsigned char 	vol;
      short 			pad2;
} OktaInstru;

typedef struct
{
	Byte	b1;
	Byte	b2;
	Byte	b3;
	Byte	b4;
} OktaPattern;

typedef struct OktaHeader
{
	char		magic[12];
	long		noChannel;
	long		chanFlag;
	long		SampleDirectory;
	long		SampleLen;
	int			splitted[4];
	
	int samp_count;
	int linesize;
	int speed;
  	int slen;
  	int plen;

  Ptr	pbod[128];
  int	pbodlen[128];
       
  unsigned char *patt;
  int pointer;
  int patty;
  int nextpt;
  int actspeed;

  int note[8];
  int vol[8];
  int per;

} OktaHeader;

static short FreqOktaTable[ 40] =
		{
			0x0358,0x0328,0x02FB,0x02D0,0x02A7,0x0281,0x025D,0x023B,0x021B,0x01FD,0x01E0,0x01C5,
			0x01AC,0x0194,0x017D,0x0168,0x0154,0x0141,0x012F,0x011E,0x010E,0x00FE,0x00F0,0x00E3,
			0x00D6,0x00CA,0x00BF,0x00B4,0x00AA,0x00A0,0x0097,0x008F,0x0087,0x007F,0x0078,0x0071
		};
#ifndef COMPIL68K 
#pragma options align=power
#endif
