/********************						***********************/
//
//	Player PRO 4.4x -- Plug IMPORT / EXPORT Definition
//
//	Version 1.0
//
//	To use with PlayerPRO for Think C & CodeWarrior
//
//	Antoine ROSSET
//	16 Tranchees
//	1206 GENEVA
//	SWITZERLAND
//	
//	FAX:			(+41 22) 346 11 97
//	Compuserve:	100277,164
//	Internet: 		rosset@dial.eunet.ch
//
//	Your main function have to be in this form:
//	OSErr main( OSType order, FSSpec *AlienFileFSSpec, MADPartition *MadFile, PPInfoRec *info, short *PitchTable);
//
//	Actual plug have to support these orders:
//
//	order: 'TEST':	check the AlienFile to see if your Plug really support it.
//	order: 'IMPT':	convert the AlienFile into a MADPartition. You have to allocate MADPartition.
//	order: 'INFO':	Fill PPInfoRec structure.
//	order: 'EXPT':	Convert the MADPartition into AlienFile. You have to allocate AlienFile.
//				Don't delete the MADPartition Structure after conversion !!
//
//	An IMPORT plug have to support these orders: 'TEST', 'IMPT', 'INFO'
//	An EXPORT plug have to support these orders: 'EXPT'
// 	An IMPORT/EXPORT plug have to support these orders: 'TEST', 'IMPT', 'INFO', 'EXPT'
//
//	About Resources:
//
//	Your Plug should have: Creator: 'SNPL', Type: 'IMPL'
//
//	Your Plug have to have these resources:
//
//	- One segment CODE 1000 with 68k Code
//	- One segment PPCC 1000 with PPC Code (OPTIONAL: if PlayerPRO in PPC cannot find it, it will use the CODE 1000 resource)
//	- One STR# resource :
//
//		1 string: which kind of files your plug support (OSType value!!!) By example: 'STrk', '669 ', etc...
//		2 string: what does your Plug: EXPL : only Export files, IMPL : only Import Files, EXIM : import AND export.
//		3 string: string that will be used in Import and Export menu of PlayerPRO
//		4 string: Copyright string of this plug.
//
/********************						***********************/

#if defined(powerc) || defined(__powerc)
#pragma options align=mac68k
#endif

typedef struct
{
	Str63	internalFileName;
	Str63	formatDescription;
	
	long		totalPatterns;
	long		partitionLength;
	
	short	totalTracks;
	short	totalInstruments;
	
	OSType	signature;
	
	long		fileSize;
	
} PPInfoRec;

#if defined(powerc) || defined(__powerc)
#pragma options align=reset
#endif

enum
{
	orderNotImplemented		= -1,
	needMoreMemory			= -2,
	fileNotSupportedByThisPlug	= -3,
	unknowError				= -4,
	cannotFindPlug				= -5
};
